"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.to-string");

var _encode = _interopRequireDefault(require("@polkadot/util-keyring/address/encode"));

var _decode = _interopRequireDefault(require("@polkadot/util-keyring/address/decode"));

var _toU8a = _interopRequireDefault(require("@polkadot/util/hex/toU8a"));

var _hex = _interopRequireDefault(require("@polkadot/util/is/hex"));

var _u8a = _interopRequireDefault(require("@polkadot/util/is/u8a"));

var _toU8a2 = _interopRequireDefault(require("@polkadot/util/u8a/toU8a"));

var _U8a = _interopRequireDefault(require("./codec/U8a"));

var _U8aFixed = _interopRequireDefault(require("./codec/U8aFixed"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A wrapper around an AccountId/PublicKey representation. Since we are dealing with
// underlying PublicKeys (32 bytes in length), we extend from U8aFixed which is
// just a Uint8Array wrapper with a fixed length.
class AccountId extends _U8aFixed.default {
  constructor(value = new Uint8Array()) {
    super(value instanceof _U8a.default ? value.raw : AccountId.decode(value), 256);
  }

  static encode(value) {
    return (0, _encode.default)(value);
  }

  static decode(value) {
    if ((0, _u8a.default)(value) || Array.isArray(value)) {
      return (0, _toU8a2.default)(value);
    } else if ((0, _hex.default)(value)) {
      return (0, _toU8a.default)(value);
    }

    return (0, _decode.default)(value);
  }

  fromJSON(input) {
    super.fromJSON(AccountId.decode(input));
    return this;
  }

  fromU8a(input) {
    super.fromU8a(input);
    return this;
  }

  toJSON() {
    return this.toString();
  }

  toString() {
    return AccountId.encode(this.raw);
  }

}

exports.default = AccountId;