"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.to-string");

var _toHex = _interopRequireDefault(require("@polkadot/util/u8a/toHex"));

var _toU8a = _interopRequireDefault(require("@polkadot/util/u8a/toU8a"));

var _U8a = _interopRequireDefault(require("./codec/U8a"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A wrapper around an AccountIndex, which is a shortened, variable-length encoding
// for an Account. We extends from U8a which is basically
// just a Uint8Array wrapper.
class AccountIndex extends _U8a.default {
  constructor(value = new Uint8Array()) {
    super(value instanceof _U8a.default ? value.raw : AccountIndex.decode(value));
  } // FIXME Not 100% sure how to handle the encoding of short addresses. It is (mostly)
  // unused atm, options are to go to hex or to utf8. Here we go the hex route.


  static encode(value) {
    return (0, _toHex.default)(value);
  }

  static decode(value) {
    return (0, _toU8a.default)(value);
  }

  fromJSON(input) {
    super.fromJSON(AccountIndex.decode(input));
    return this;
  } // TODO Without specific data and actual real-world tests, unsure about how the
  // actual encoding here fits together. It is quite possibly prefix-encoded, so
  // prefixes may have to be stripped.


  fromU8a(input) {
    super.fromU8a(input);
    return this;
  }

  toJSON() {
    return this.toString();
  }

  toString() {
    return AccountIndex.encode(this.raw);
  }

}

exports.default = AccountIndex;