import { AnyNumber, AnyU8a } from './types';
import Struct from './codec/Struct';
import Tuple from './codec/Tuple';
import Vector from './codec/Vector';
import AuthorityId from './AuthorityId';
import Hash from './Hash';
import Signature from './Signature';
import U32 from './U32';
export declare type BftAuthoritySignatureValue = {
    authorityId?: AnyU8a;
    signature?: AnyU8a;
};
export declare class BftAuthoritySignature extends Tuple {
    constructor(value?: BftAuthoritySignatureValue);
    readonly authorityId: AuthorityId;
    readonly signature: Signature;
}
export declare type BftHashSignatureValue = {
    hash?: AnyU8a;
    signature?: AnyU8a;
};
export declare class BftHashSignature extends Tuple {
    constructor(value?: BftHashSignatureValue);
    readonly hash: Hash;
    readonly signature: Signature;
}
export declare type JustificationValue = {
    round?: AnyNumber;
    hash?: AnyU8a;
    signatures?: Array<BftAuthoritySignatureValue>;
};
export declare class Justification extends Struct {
    constructor(value?: JustificationValue);
    readonly hash: Hash;
    readonly round: U32;
    readonly signatures: Vector<BftAuthoritySignature>;
}
