"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _asU8a = _interopRequireDefault(require("@polkadot/util-crypto/blake2/asU8a"));

var _Struct = _interopRequireDefault(require("./codec/Struct"));

var _Extrinsics = _interopRequireDefault(require("./Extrinsics"));

var _Hash = _interopRequireDefault(require("./Hash"));

var _Header = _interopRequireDefault(require("./Header"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A block encoded with header and extrinsics
class Block extends _Struct.default {
  constructor(value) {
    super({
      header: _Header.default,
      extrinsics: _Extrinsics.default
    }, value);
  }

  get extrinsics() {
    return this.raw.extrinsics;
  } // convenience, encodes the header and returns the actual hash


  get hash() {
    return new _Hash.default((0, _asU8a.default)(this.toU8a(), 256));
  }

  get header() {
    return this.raw.header;
  }

}

exports.default = Block;