"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Base = _interopRequireDefault(require("./codec/Base"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
class Bool extends _Base.default {
  constructor(value = false) {
    super(value instanceof Bool ? value.raw : value);
  }

  byteLength() {
    return 1;
  }

  fromJSON(input) {
    this.raw = input === true;
    return this;
  }

  fromU8a(input) {
    this.raw = input[0] === 1;
    return this;
  }

  toJSON() {
    return this.raw;
  }

  toU8a(isBare) {
    return new Uint8Array([this.raw ? 1 : 0]);
  }

  toString() {
    return `${this.raw}`;
  }

}

exports.default = Bool;