"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _concat = _interopRequireDefault(require("@polkadot/util/u8a/concat"));

var _Length = _interopRequireDefault(require("./codec/Length"));

var _U8a = _interopRequireDefault(require("./codec/U8a"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A Bytes. The significant difference between this and a normal Uint8Array is that
// this version allows for length-encoding. (i.e. it is a variable-item codec, the same
// as what is found in String and Array)
class Bytes extends _U8a.default {
  constructor(value) {
    super(value);
    this._length = void 0;
    this._length = new _Length.default(this.raw.length);
  }

  get length() {
    return this._length.toNumber();
  }

  byteLength() {
    return this._length.byteLength() + this.length;
  }

  fromJSON(input) {
    super.fromJSON(input);

    this._length.setValue(this.raw.length);

    return this;
  }

  fromU8a(input) {
    this._length.fromU8a(input);

    const length = this._length.toNumber();

    const offset = this._length.byteLength();

    super.fromU8a(input.subarray(offset, offset + length));
    return this;
  }

  toU8a(isBare) {
    return (0, _concat.default)(this._length.toU8a(isBare), this.raw);
  }

}

exports.default = Bytes;