import { AnyNumber, AnyU8a } from './types';
import Struct from './codec/Struct';
import Vector from './codec/Vector';
import BlockNumber from './BlockNumber';
import Bytes from './Bytes';
import Hash from './Hash';
declare type DigestValue = {
    logs?: Array<AnyU8a>;
};
export declare type HeaderValue = {
    digest?: DigestValue;
    extrinsicsRoot?: AnyU8a;
    number?: AnyNumber;
    parentHash?: AnyU8a;
    stateRoot?: AnyU8a;
};
export declare class Digest extends Struct {
    constructor(value?: DigestValue);
    readonly logs: Vector<Bytes>;
}
export default class Header extends Struct {
    constructor(value?: HeaderValue);
    readonly blockNumber: BlockNumber;
    readonly digest: Digest;
    readonly extrinsicsRoot: Hash;
    readonly hash: Hash;
    readonly parentHash: Hash;
    readonly stateRoot: Hash;
}
export {};
