import { AnyNumber } from './types';
import Vector from './codec/Vector';
import Enum from './codec/Enum';
import EnumType from './codec/EnumType';
import Struct from './codec/Struct';
import Text from './Text';
import Type from './Type';
import U16 from './U16';
export declare class EventMetadata extends Struct {
    constructor(value?: any);
    readonly arguments: Vector<Type>;
    readonly documentation: Vector<Text>;
    readonly name: Text;
}
export declare class OuterEventMetadataEvent extends Struct {
    constructor(value?: any);
    readonly events: Vector<EventMetadata>;
    readonly name: Text;
}
export declare class OuterEventMetadata extends Struct {
    constructor(value?: any);
    readonly events: Vector<OuterEventMetadataEvent>;
    readonly name: Text;
}
export declare class FunctionArgumentMetadata extends Struct {
    constructor(value?: any);
    readonly name: Text;
    readonly type: Type;
}
export declare class FunctionMetadata extends Struct {
    constructor(value?: any);
    readonly arguments: Vector<FunctionArgumentMetadata>;
    readonly documentation: Vector<Text>;
    readonly id: U16;
    readonly name: Text;
}
export declare class CallMetadata extends Struct {
    constructor(value?: any);
    readonly functions: Vector<FunctionMetadata>;
    readonly name: Text;
}
export declare class ModuleMetadata extends Struct {
    constructor(value?: any);
    readonly call: CallMetadata;
    readonly name: Text;
}
export declare class StorageFunctionModifier extends Enum {
    constructor(value?: any);
}
export declare class StorageFunctionType$Map extends Struct {
    constructor(value?: any);
    readonly key: Type;
    readonly value: Type;
}
export declare class StorageFunctionType extends EnumType<Type | StorageFunctionType$Map> {
    constructor(index?: number, value?: any);
    readonly isMap: boolean;
    readonly asMap: StorageFunctionType$Map;
    readonly asType: Type;
    toString(): string;
}
declare type StorageFunctionMetadataValue = {
    name?: string | Text;
    modifier?: StorageFunctionModifier | AnyNumber;
    type?: StorageFunctionType;
    documentation?: Vector<Text> | Array<string>;
};
export declare class StorageFunctionMetadata extends Struct {
    constructor(value?: StorageFunctionMetadataValue);
    readonly documentation: Vector<Text>;
    readonly name: Text;
    readonly modifier: StorageFunctionModifier;
    readonly type: StorageFunctionType;
}
export declare class StorageMetadata extends Struct {
    constructor(value?: any);
    readonly functions: Vector<StorageFunctionMetadata>;
    readonly prefix: Text;
}
export declare class RuntimeModuleMetadata extends Struct {
    constructor(value?: any);
    readonly module: ModuleMetadata;
    readonly prefix: Text;
    readonly storage: StorageMetadata | undefined;
}
export default class RuntimeMetadata extends Struct {
    constructor(value?: any);
    fromJSON(input: Uint8Array | string | Array<number>): RuntimeMetadata;
    toJSON(): any;
    readonly events: Vector<OuterEventMetadataEvent>;
    readonly modules: Vector<RuntimeModuleMetadata>;
    getUniqTypes(): Array<string>;
}
export {};
