import { AnyNumber } from './types';
import EnumType from './codec/EnumType';
import Struct from './codec/Struct';
import AuthorityId from './AuthorityId';
import { BftHashSignature, BftHashSignatureValue } from './Bft';
import BlockNumber from './BlockNumber';
import Hash from './Hash';
import U32 from './U32';
declare type BftAtReportValue = {
    round?: AnyNumber;
    a?: BftHashSignatureValue;
    b?: BftHashSignatureValue;
};
export declare class BftAtReport extends Struct {
    constructor(value?: BftAtReportValue);
    readonly a: BftHashSignature;
    readonly b: BftHashSignature;
    readonly round: U32;
}
export declare class BftDoublePrepare extends BftAtReport {
}
export declare class BftDoubleCommit extends BftAtReport {
}
export declare class MisbehaviorKind extends EnumType<BftDoublePrepare | BftDoubleCommit> {
    constructor(index?: number, value?: BftAtReportValue);
}
declare type MisbehaviorReportValue = {
    unstakeThreshold?: AnyNumber;
    validatorPayment?: AnyNumber;
};
export default class MisbehaviorReport extends Struct {
    constructor(value?: MisbehaviorReportValue);
    readonly misbehavior: MisbehaviorKind;
    readonly parentHash: Hash;
    readonly parentNumber: BlockNumber;
    readonly target: AuthorityId;
}
export {};
