import { AnyNumber, AnyU8a } from './types';
import Struct from './codec/Struct';
import Tuple from './codec/Tuple';
import Vector from './codec/Vector';
import Text from './Text';
import U32 from './U32';
import U8aFixed from '@polkadot/api-codec/codec/U8aFixed';
declare class ApiId extends U8aFixed {
    constructor(value?: AnyU8a);
}
declare type RuntimeVersionApiValue = {
    id?: AnyU8a;
    version?: AnyNumber;
};
declare class RuntimeVersionApi extends Tuple {
    constructor(value?: RuntimeVersionApiValue);
    readonly id: ApiId;
    readonly version: U32;
}
declare type RuntimeVersionValue = {
    specName?: string;
    implName?: string;
    authoringVersion?: AnyNumber;
    specVersion?: AnyNumber;
    implVersion?: AnyNumber;
    apis?: Array<RuntimeVersionApiValue>;
};
export default class RuntimeVersion extends Struct {
    constructor(value?: RuntimeVersionValue);
    readonly apis: Vector<RuntimeVersionApi>;
    readonly authoringVersion: U32;
    readonly implName: Text;
    readonly implVersion: U32;
    readonly specName: Text;
    readonly specVersion: U32;
}
export {};
