"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

var _Struct = _interopRequireDefault(require("./codec/Struct"));

var _Tuple = _interopRequireDefault(require("./codec/Tuple"));

var _Vector = _interopRequireDefault(require("./codec/Vector"));

var _Text = _interopRequireDefault(require("./Text"));

var _U = _interopRequireDefault(require("./U32"));

var _U8aFixed = _interopRequireDefault(require("@polkadot/api-codec/codec/U8aFixed"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
class ApiId extends _U8aFixed.default {
  constructor(value) {
    super(value, 64);
  }

}

class RuntimeVersionApi extends _Tuple.default {
  constructor(value) {
    super({
      id: ApiId,
      version: _U.default
    }, value);
  }

  get id() {
    return this.raw.id;
  }

  get version() {
    return this.raw.version;
  }

}

class RuntimeVersion extends _Struct.default {
  constructor(value) {
    super({
      specName: _Text.default,
      implName: _Text.default,
      authoringVersion: _U.default,
      specVersion: _U.default,
      implVersion: _U.default,
      apis: _Vector.default.with(RuntimeVersionApi)
    }, value, new Map([['authoringVersion', 'authoring_version'], ['implName', 'impl_name'], ['implVersion', 'impl_version'], ['specName', 'spec_name'], ['specVersion', 'spec_version']]));
  }

  get apis() {
    return this.raw.apis;
  }

  get authoringVersion() {
    return this.raw.authoringVersion;
  }

  get implName() {
    return this.raw.implName;
  }

  get implVersion() {
    return this.raw.implVersion;
  }

  get specName() {
    return this.raw.specName;
  }

  get specVersion() {
    return this.raw.specVersion;
  }

}

exports.default = RuntimeVersion;