"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Struct = _interopRequireDefault(require("./codec/Struct"));

var _Vector = _interopRequireDefault(require("./codec/Vector"));

var _Hash = _interopRequireDefault(require("./Hash"));

var _KeyValue = require("./KeyValue");

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A set of storage changes. It contains the hash/block and
// a list of the actual changes that took place
class StorageChangeSet extends _Struct.default {
  constructor(value) {
    super({
      hash: _Hash.default,
      changes: _Vector.default.with(_KeyValue.KeyValueOption)
    }, value);
  }

  get changes() {
    return this.raw.changes;
  }

  get hash() {
    return this.raw.hash;
  }

}

exports.default = StorageChangeSet;