import { AnyU8a } from './types';
import Bytes from './Bytes';
import { StorageFunctionMetadata } from './Metadata';
export interface StorageFunction {
    (arg?: any): Uint8Array;
    meta: StorageFunctionMetadata;
    method: string;
    section: string;
    toJSON: () => any;
}
export default class StorageKey extends Bytes {
    private _outputType;
    constructor(value: AnyU8a | StorageKey | StorageFunction | [StorageFunction, any]);
    static encode(value: AnyU8a | StorageKey | StorageFunction | [StorageFunction, any]): Uint8Array;
    static getType(value: StorageKey | StorageFunction | [StorageFunction, any]): string | null;
    readonly outputType: string | null;
}
