"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/es6.regexp.to-string");

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _function = _interopRequireDefault(require("@polkadot/util/is/function"));

var _toU8a = _interopRequireDefault(require("@polkadot/util/u8a/toU8a"));

var _U8a = _interopRequireDefault(require("./codec/U8a"));

var _Bytes = _interopRequireDefault(require("./Bytes"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A representation of a storage key (typically hashed) in the system. It can be constructed
// by passing in a raw key or a StorageFunction with (optional) arguments.
class StorageKey extends _Bytes.default {
  constructor(value) {
    super(StorageKey.encode(value));
    this._outputType = void 0;
    this._outputType = StorageKey.getType(value);
  }

  static encode(value) {
    if (value instanceof StorageKey || value instanceof _U8a.default) {
      return value.raw;
    } else if ((0, _function.default)(value)) {
      return value();
    } else if (Array.isArray(value)) {
      const _value = (0, _slicedToArray2.default)(value, 2),
            fn = _value[0],
            arg = _value[1];

      if ((0, _function.default)(fn)) {
        return fn(arg);
      }
    }

    return (0, _toU8a.default)(value);
  }

  static getType(value) {
    if (value instanceof StorageKey) {
      return value.outputType;
    } else if ((0, _function.default)(value)) {
      return value.meta.type.toString();
    } else if (Array.isArray(value)) {
      const _value2 = (0, _slicedToArray2.default)(value, 1),
            fn = _value2[0];

      return fn.meta.type.toString();
    }

    return null;
  }

  get outputType() {
    return this._outputType;
  }

}

exports.default = StorageKey;