"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _Base = _interopRequireDefault(require("./Base"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A codec wrapper for an enum. Enums are encoded as a single byte, where the byte
// is a zero-indexed value. This class allows you to retrieve the value either
// by `toNumber()` exposing the actual raw index, or `toString()` returning a
// string representation (as provided as part of the constructor)
//
// TODO:
//   - It would be great if this could actually wrap actual TS enums
class Enum extends _Base.default {
  constructor(def, value = 0) {
    super(value instanceof Enum ? value.raw : value);
    this._enum = void 0;
    this._enum = def;
  }

  byteLength() {
    return 1;
  }

  fromJSON(input) {
    // FIXME We potentially want to assert that the value is actually inside this._enum
    this.raw = input;
    return this;
  }

  fromU8a(input) {
    // FIXME We potentially want to assert that the value is actually inside this._enum
    this.raw = input[0];
    return this;
  }

  toJSON() {
    return this.raw;
  }

  toU8a(isBare) {
    return new Uint8Array([this.raw]);
  }

  toNumber() {
    return this.raw;
  }

  toString() {
    return this._enum[this.raw] || `${this.raw}`;
  }

}

exports.default = Enum;