"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

var _Base = _interopRequireDefault(require("./Base"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// This implements an enum, that based on the value wraps a different type. It is effectively an
// extension to enum where the value type is determined by the actual index.
//
// TODO:
//   - As per Enum, actually use TS enum
//   - It should rather probably extend Enum instead of copying code
//   - There doesn't actually seem to be a way to get to the actual determined/wrapped value
class EnumType extends _Base.default {
  constructor(def, index, value) {
    super(new (Object.values(def)[0])());
    this._Types = void 0;
    this._index = void 0;
    this._indexes = void 0;
    this._Types = Array.isArray(def) ? def : Object.values(def);
    this._indexes = Object.keys(def).map(index => parseInt(index, 10));
    this._index = this._indexes[0];
    this.setValue(index, value);
  }

  get Type() {
    return this._Types[this._index].name;
  }

  byteLength() {
    return 1 + this.raw.byteLength();
  }

  fromU8a(input) {
    this.setValue(input[0]);
    this.raw.fromU8a(input.subarray(1));
    return this;
  }

  setValue(index, value) {
    if (index instanceof EnumType) {
      this._index = index._index;
      this.raw = new this._Types[this._index](index.raw);
      return;
    }

    this._index = this._indexes.indexOf(index || 0);

    if (this._index === -1) {
      this._index = this._indexes[0];
    }

    this.raw = new this._Types[this._index](value);
  }

  toJSON() {
    return this.raw;
  }

  toNumber() {
    return this._index;
  }

  toString() {
    return this._Types[this._index].name;
  }

}

exports.default = EnumType;