"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _bn = _interopRequireDefault(require("bn.js"));

var _toBn = _interopRequireDefault(require("@polkadot/util/bn/toBn"));

var _toHex = _interopRequireDefault(require("@polkadot/util/u8a/toHex"));

var _Base = _interopRequireDefault(require("./Base"));

var _Compact = _interopRequireDefault(require("./Compact"));

var _UInt = _interopRequireDefault(require("./UInt"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A Length-prefix that can be added to any variable length stream of bytes, e.g. String,
// Vectors and Bytes
//
// FIXME Not crazy about the use of Length. If we look at Vector, Bytes & String,
// the implementations are basically the same. Vector is slightly different since
// it iterates over the length. We need a cleaner way where we have less copied
// code and a more generic implementation around the use of Length. Looking at
// Array or Struct, the same type of wrapper would be useful here.
class Length extends _Base.default {
  constructor(value = new _bn.default(0), bitLength = 32) {
    super(_UInt.default.decode(value));
    this._bitLength = void 0;
    this._bitLength = bitLength;
  }

  byteLength() {
    return this.toU8a().length;
  }

  fromU8a(input) {
    this.raw = _Compact.default.decode(input, this._bitLength);
    return this;
  }

  toHex() {
    return (0, _toHex.default)(this.toU8a());
  }

  toNumber() {
    return this.raw.toNumber();
  }

  toU8a(isBare) {
    return isBare ? new Uint8Array() : _Compact.default.encode(this.raw, this._bitLength);
  }

  setValue(value) {
    this.raw = (0, _toBn.default)(value);
  }

}

exports.default = Length;