import Base from './Base';
export default class Struct<S = {
    [index: string]: {
        new (value?: any): Base;
    };
}, T = {
    [K in keyof S]: Base;
}, V = {
    [K in keyof S]: any;
}, E = {
    [K in keyof S]: string;
}> extends Base<T> {
    protected _jsonMap: Map<keyof S, string>;
    protected _Types: E;
    constructor(Types: S, value?: V | Array<any>, jsonMap?: Map<keyof S, string>, isTuple?: boolean);
    static decode<S, V, T>(Types: S, value: V | Array<any>, isTuple: boolean): T;
    static with<S = {
        [index: string]: {
            new (value?: any): Base;
        };
    }>(Types: S): {
        new (value?: any): Struct<S>;
    };
    readonly Type: E;
    byteLength(): number;
    fromJSON(input: any): Struct<S, T, V, E>;
    fromU8a(input: Uint8Array): Struct<S, T, V, E>;
    get(index: number): Base;
    toJSON(): any;
    keys(): Array<string>;
    toU8a(isBare?: boolean): Uint8Array;
    toString(): string;
    values(): Array<Base>;
}
