"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

require("core-js/modules/web.dom.iterable");

var _toU8a = _interopRequireDefault(require("@polkadot/util/hex/toU8a"));

var _hex = _interopRequireDefault(require("@polkadot/util/is/hex"));

var _Struct = _interopRequireDefault(require("./Struct"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A Tuple defines an anonymous Object with key/values - where the values are Base<T> values.It
// is a specialization of the Struct type where the toJSON/fromJSON operates on Array structures,
// while the U8a encoding is handled in the same way as a Struct
class Tuple extends _Struct.default {
  constructor(Types, value, jsonMap) {
    super(Types, value, jsonMap, true);
  }

  static with(Types) {
    return class extends Tuple {
      constructor(value) {
        super(Types, value);
      }

    };
  }

  fromJSON(input) {
    if ((0, _hex.default)(input)) {
      return this.fromU8a((0, _toU8a.default)(input));
    }

    Object.values(this.raw).forEach((entry, index) => {
      entry.fromJSON(input[index]);
    });
    return this;
  }

  toJSON() {
    return Object.values(this.raw).map(entry => entry.toJSON());
  }

}

exports.default = Tuple;