"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _toHex = _interopRequireDefault(require("@polkadot/util/u8a/toHex"));

var _toU8a = _interopRequireDefault(require("@polkadot/util/u8a/toU8a"));

var _Base = _interopRequireDefault(require("./Base"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A U8a. A basic wrapper around Uint8Array, with no frills and no fuss. It
// wraps a Uint8Array. It does differ from other implementations wher it will
// consume the full u8a as passed to it in fromU8a. As such it is meant to be
// subclassed where the wrapper takes care of the actual lengths.
class U8a extends _Base.default {
  constructor(value = new Uint8Array()) {
    super(value instanceof U8a ? value.raw : (0, _toU8a.default)(value));
  }

  get length() {
    return this.byteLength();
  }

  byteLength() {
    return this.raw.length;
  }

  fromJSON(input) {
    this.raw = (0, _toU8a.default)(input);
    return this;
  }

  fromU8a(input) {
    this.raw = input;
    return this;
  }

  toHex() {
    return (0, _toHex.default)(this.raw);
  }

  toJSON() {
    return this.toHex();
  }

  toU8a(isBare) {
    return this.raw;
  }

  toString() {
    return this.toHex();
  }

}

exports.default = U8a;