"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _U8a = _interopRequireDefault(require("./U8a"));

// Copyright 2017-2018 @polkadot/api-codec authors & contributors
// This software may be modified and distributed under the terms
// of the ISC license. See the LICENSE file for details.
// A U8a that manages a a sequence of bytes up to the specified bitLength. Not meant
// to be used directly, rather is should be subclassed with the specific lengths.
class U8aFixed extends _U8a.default {
  constructor(value = new Uint8Array(), bitLength = 256) {
    super(value);
    this._bitLength = void 0;
    this._bitLength = bitLength;

    this._trimLength();
  }

  _trimLength() {
    this.raw = this.raw.subarray(0, this.byteLength());
  }

  byteLength() {
    return this._bitLength / 8;
  }

  fromJSON(input) {
    super.fromJSON(input);

    this._trimLength();

    return this;
  }

  fromU8a(input) {
    super.fromU8a(input.subarray(0, this.byteLength()));
    return this;
  }

}

exports.default = U8aFixed;