import { AnyNumber } from '../types';
import BN from 'bn.js';
import Base from './Base';
declare type BitLength = 8 | 16 | 32 | 64 | 128 | 256;
export default class UInt extends Base<BN> {
    private _bitLength;
    constructor(value?: AnyNumber, bitLength?: BitLength);
    static decode(value: AnyNumber): BN;
    byteLength(): number;
    fromJSON(input: any): UInt;
    fromU8a(input: Uint8Array): UInt;
    toHex(): string;
    toJSON(): any;
    toU8a(isBare?: boolean): Uint8Array;
    toString(): string;
    toBn(): BN;
    toNumber(): number;
    add(other: UInt | BN | number): BN;
    cmp(other: UInt | BN | number): number;
    div(other: UInt | BN | number): BN;
    isZero(): boolean;
    lt(test: UInt | BN | number): boolean;
    lte(test: UInt | BN | number): boolean;
    gt(test: UInt | BN | number): boolean;
    gte(test: UInt | BN | number): boolean;
    mul(other: UInt | BN | number): BN;
    sub(other: UInt | BN | number): BN;
}
export {};
